<template>
  <div>
    <section class="mb-3 white--text py-5">
      <v-container>

        <v-row>
          <h1 class="black--text main-title"><b>{{ user.firstName }}</b>, voici le calendrier de vos rendez-vous :</h1>
        </v-row>

        <v-row class="fill-height">
          <v-col>
            <v-sheet height="64">
              <v-toolbar
                  flat
              >
                <v-btn
                    outlined
                    class="mr-4"
                    color="grey darken-2"
                    @click="setToday"
                >
                  Aujourd'hui
                </v-btn>
                <v-btn
                    fab
                    text
                    small
                    color="grey darken-2"
                    @click="prev"
                >
                  <v-icon small>
                    mdi-chevron-left
                  </v-icon>
                </v-btn>
                <v-btn
                    fab
                    text
                    small
                    color="grey darken-2"
                    @click="next"
                >
                  <v-icon small>
                    mdi-chevron-right
                  </v-icon>
                </v-btn>
                <v-toolbar-title v-if="$refs.calendar">
                  {{ $refs.calendar.title }}
                </v-toolbar-title>
                <v-spacer></v-spacer>
                <v-menu
                    bottom
                    right
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                        outlined
                        color="grey darken-2"
                        v-bind="attrs"
                        v-on="on"
                    >
                      <span>{{ typeToLabel[type] }}</span>
                      <v-icon right>
                        mdi-menu-down
                      </v-icon>
                    </v-btn>
                  </template>
                  <v-list>
                    <v-list-item @click="type = index" v-for="(name, index) in typeToLabel" :key="index">
                      <v-list-item-title>{{ name }}</v-list-item-title>
                    </v-list-item>
                  </v-list>
                </v-menu>
              </v-toolbar>
            </v-sheet>
            <v-sheet height="600">
              <v-calendar
                  ref="calendar"
                  v-model="focus"
                  color="primary"
                  :events="events"
                  :event-color="getEventColor"
                  :type="type"
                  @click:event="showEvent"
                  @click:more="viewDay"
                  @click:date="viewDay"
                  @change="updateRange"
              ></v-calendar>
              <v-menu
                  v-model="selectedOpen"
                  :close-on-content-click="false"
                  :activator="selectedElement"
                  offset-x
              >
                <v-card
                    color="grey lighten-4"
                    min-width="350px"
                    flat
                >
                  <v-toolbar
                      :color="selectedEvent.color"
                      dark
                  >
                    <v-toolbar-title v-html="selectedEvent.name"></v-toolbar-title>
                  </v-toolbar>
                  <v-card-text>
                    <span v-html="selectedEvent.details"></span>
                  </v-card-text>
                  <v-card-actions class="d-flex flex-justify-space-between">
                    <v-btn
                        large color="secondary"
                        @click="selectedOpen = false"
                    >
                      Retour
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-btn
                        large color="error"

                        @click="deleteAppointmentDialog"
                    >
                      Supprimer
                    </v-btn>
                  </v-card-actions>

                </v-card>
              </v-menu>
            </v-sheet>
          </v-col>
          <v-dialog v-model="dialogDeleteAppointment" max-width="580px">
            <v-card>
              <v-card-title class="headline my-4 justify-center">Etes-vous sûr de vouloir annuler ce rendez-vous ?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="secondary lighten-3" text @click="closeDeleteAppointmentDialog">Annuler</v-btn>
                <v-btn color="error" text @click="confirmDeleteAppointmentDialog">Supprimer</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-snackbar
              v-model="confirmDeleteSnackbar"
              :timeout=2000
              color="success"
          >
            Votre rendez-vous à été annulé.
            <v-btn
                color="white" text
                @click="confirmDeleteSnackbar = false"
            >
              Fermer
            </v-btn>
          </v-snackbar>


          <v-snackbar
              v-model="errorOnDeleteAppointment"
              :timeout=2000
              color="error"
          >
            Une erreur est survenue, veuillez actualiser la page
            <v-btn
                color="red" text
                @click="errorOnDeleteAppointment = false"
            >
              Fermer
            </v-btn>
          </v-snackbar>
        </v-row>
      </v-container>
    </section>
  </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';

export default {
  data: () => ({
    dialogDeleteAppointment: false,
    currentAppointmentIdToDelete: null,
    confirmDeleteSnackbar: false,
    errorOnDeleteAppointment: false,
    focus: '',
    type: 'month',
    typeToLabel: {
      week: 'Semaine',
      month: 'Mois',
      day: 'Jour',
      '4day': '4 jours',
    },
    selectedEvent: {},
    selectedElement: null,
    selectedOpen: false,
    events: [],
  }),
  methods: {
    ...mapActions(['loadCurrentUser', 'loadCaresByIdUserPro', 'loadCareType', 'deleteAppointmentSaveId']),
    deleteAppointmentDialog() {
      this.dialogDeleteAppointment = true
    },
    closeDeleteAppointmentDialog() {
      this.dialogDeleteAppointment = false;
      //this.currentAppointmentIdToDelete = null;
    },
    confirmDeleteAppointmentDialog() {
      if (typeof this.currentAppointmentIdToDelete === 'number' && this.currentAppointmentIdToDelete !== null) {
        this.deleteAppointmentSaveId(this.currentAppointmentIdToDelete)
            .then(() => {
              this.dialogDeleteAppointment = false;
              this.confirmDeleteSnackbar = true;
              this.updateRange();
            });
      } else {
        this.errorOnDeleteAppointment = true;
      }
    },
    viewDay({date}) {
      this.focus = date
      this.type = 'day'
    },
    getEventColor(event) {
      return event.color
    },
    setToday() {
      this.focus = ''
    },
    prev() {
      this.$refs.calendar.prev()
    },
    next() {
      this.$refs.calendar.next()
    },
    showEvent({nativeEvent, event}) {
      //On stock l'Id du rdv sur lequel on a cliqué
      this.currentAppointmentIdToDelete = (typeof event.id === 'number' && event.id !== null) ? event.id : null
      const open = () => {
        this.selectedEvent = event
        this.selectedElement = nativeEvent.target

        setTimeout(() => {
          this.selectedOpen = true
        }, 10)
      }
      if (this.selectedOpen) {
        this.selectedOpen = false
        setTimeout(open, 10)
      } else {
        open()
      }
      nativeEvent.stopPropagation()
    },
    async updateRange() {
      await this.loadCurrentUser(localStorage.getItem('token'));

      let allDataAppointmentsOfUserProTmp = [];

      if (typeof this.user.id !== undefined) {
        await this.loadCaresByIdUserPro(this.user.id);
        let allAppointmentsOfUserProBrutData = this.getCares;

        if (typeof allAppointmentsOfUserProBrutData['hydra:member'] !== 'undefined' &&
            allAppointmentsOfUserProBrutData['hydra:member'] !== null &&
            allAppointmentsOfUserProBrutData['hydra:member'].length > 0) {
          this.AllAppointment = [];

          for (const element of allAppointmentsOfUserProBrutData['hydra:member']) {
            if (typeof element.appointments != 'undefined' && typeof element.office !== 'undefined' && typeof element.type !== 'undefined') {
              await this.loadCareType(element.type);

              let name = (typeof this.getCurrentCareType !== 'undefined' && typeof this.getCurrentCareType.label !== 'undefined' && this.getCurrentCareType.label !== null) ? this.getCurrentCareType.label : 'Type de Rdv non spécifié';

              if (element.appointments.length == 1) {
                let dateStart = new Date(element.appointments[0].date);
                let dateEnd = new Date();
                dateEnd.setTime(dateStart.getTime() + (30 * 60 * 1000));
                let colorItem = (typeof this.getCurrentCareType.color_schedule !== 'undefined' && this.getCurrentCareType.color_schedule !== null) ? this.getCurrentCareType.color_schedule : "green";

                allDataAppointmentsOfUserProTmp.push({
                  name: name,
                  start: dateStart,
                  end: dateEnd,
                  color: colorItem,
                  timed: true,
                  id: element.appointments[0].id
                })
              } else if (element.appointments.length > 1) {
                for (let appointmentItem of element.appointments) {
                  let dateStart = new Date(appointmentItem.date);
                  let dateEnd = new Date();
                  dateEnd.setTime(dateStart.getTime() + (30 * 60 * 1000));
                  let colorItem = (typeof this.getCurrentCareType.color_schedule !== 'undefined' && this.getCurrentCareType.color_schedule !== null) ? this.getCurrentCareType.color_schedule : "green";

                  allDataAppointmentsOfUserProTmp.push({
                    name: name,
                    start: dateStart,
                    end: dateEnd,
                    color: colorItem,
                    timed: true,
                    id: appointmentItem.id
                  })
                }
              }
            }
          }
        }
      }
      this.events = allDataAppointmentsOfUserProTmp;
    },
  },
  computed: {
    ...mapGetters(['user', 'getCares', 'getCurrentCareType'])
  },
  async mounted() {
    this.$refs.calendar.checkChange();
  }
  ,
}
</script>